{ fp }
//
// Problem  : Wisemen
// Contest  : UOI-2007 (Kremenchug)
// Type     : Solution
// Date     : March, 28th, 2007
// Version  : 1.0
// Author   : Andriy Stasyuk
// Language : Pascal
// Compiler : FP
// Algorithm: Author Solution
//

const
  MAX = 1000000;
  INF = maxlongint;
var
  N, M, K: longint;
  Ms, Ps, WC: array[1..MAX] of longint;
  min, i: longint;
  needspace: boolean;
  f: text;
begin
  assign(f, 'wisemen.dat');
  reset(f);
  readln(f, N, M, K);
  for i := 1 to K do
    read(f, Ms[i]);
  for i := 1 to N do
  begin
    read(f, WC[i]);
    inc(Ps[WC[i]]);
  end;
  close(f);

  min := INF;
  for i := 1 to K do
    if M - Ms[i] < N then
      if M - N - Ms[i] + Ps[i] < min then
        min := M - N - Ms[i] + Ps[i];

  assign(f, 'wisemen.sol');
  rewrite(f);
  if min = INF then
    writeln(f, 0)
  else
  begin
    needspace := false;
    for i := 1 to N do
      if (M - Ms[WC[i]] < N) AND (M - N - Ms[WC[i]] + Ps[WC[i]] = min) then
      begin
        if needspace then write(f, ' ');
        write(f, i);
        needspace := true;
      end;
    writeln(f);
    writeln(f, min+1);
  end;
  close(f);
end.
